diff --git a/eos/private/pc_eos.f90 b/eos/private/pc_eos.f90
index 73031183..f9641a13 100644
--- a/eos/private/pc_eos.f90
+++ b/eos/private/pc_eos.f90
@@ -1,7 +1,5 @@
       module pc_eos
-      use utils_lib
       use math_lib
-      use auto_diff
       use const_def, only: dp, PI
 
       implicit none
@@ -14,9 +12,8 @@
 ! Please communicate comments/suggestions to Alexander Potekhin:
 !                                            palex@astro.ioffe.ru
 ! Previously distributed versions (obsolete):
-!   eos2000, eos2002, eos2004, eos2006, eos2007, eos2009, eos10, eos11,
-!     and eos13.
-! Last update: 28.05.15. All updates since 2008 are listed below.
+!   eos2000, eos2002, eos2004, eos2006, eos2007, and eos2009.
+! Last updated 21.06.10
 !*   L I S T   O F   S U B R O U T I N E S :
 !  MAIN (normally commented-out) - example driving routine.
 !  MELANGE9 - for arbitrary ionic mixture, renders total (ion+electron)
@@ -41,17 +38,17 @@
 !          internal energies, pressure, entropy, heat capacity,
 !          derivatives of pressure over logarithms of temperature and
 !          density for monoionic solid.
-!  FHARM12 - harmonic (including static-lattice and zero-point)
-!          contributions to the free and internal energies, pressure,
-!          entropy, heat capacity, derivatives of pressure over
-!          logarithms of temperature and density for solid OCP.
-!  HLfit12 - the same as FHARM12, but only for thermal contributions
+!  FHARM8 - harmonic (including static-lattice) contributions
+!          to the free and internal energies, pressure, entropy, heat
+!          capacity, derivatives of pressure over logarithms of
+!          temperature and density for solid OCP.
+!  HLfit8 - the same as FHARM8, but without the Madelung contribution
 !  ANHARM8 - anharmonic contributions to the free and internal energies,
 !          pressure, entropy, heat capacity, derivatives of pressure
 !          over logarithms of temperature and density for solid OCP.
 !  CORMIX - correction to the linear mixing rule for the Coulomb
-!          contributions to the thermodynamic functions in the liquid.
-!  ELECT11 - for an ideal electron gas of arbitrary degeneracy and
+!          contributions to the thermodynamic functions.
+!  ELECT9 - for an ideal electron gas of arbitrary degeneracy and
 !          relativity at given temperature and electron chemical
 !          potential, renders number density (in atomic units), free
 !          energy, pressure, internal energy, entropy, heat capacity 
@@ -71,7 +68,7 @@
 !          temperature and the second derivative over temperature.
 !*   I M P R O V E M E N T S   O F   2 0 0 8  -  2 0 0 9 :
 !  FHARM8 uses a fit HLfit8 to the thermal free energy of the harmonic
-!   Coulomb lattice, which is more accurate than its predecessor FHARM7.
+!   Coulomb lattice, which is more accurate than its predecessor FHARM7..
 !   Resulting corrections amount up to 20% for the ion heat capacity.
 !   Accordingly, S/R D3fit and FthCHA7 deleted (not used anymore).
 !  BLIN7 upgraded to BLIN8:
@@ -84,24 +81,10 @@
 !    are not considered, the corresponding inputs (AYLR, AYLT) are
 !    excluded from MELANGE8 (and EOSFI7 changed to EOSFI8 accordingly).
 !  ELECT7 upgraded to ELECT9 (high-degeneracy behaviour is improved)
-!*   P O S T - P U B L I C A T I O N    (2 0 1 0 +)   IMPROVEMENTS :
-!  ELECT9 upgraded (smooth match of two fits at chi >> 1)
+!*   I M P R O V E M E N T S   O F   2 0 1 0 :
+!  ELECT9 upgraded (smooth match of two fits at chi=14)
 !  BLIN8 replaced by BLIN9 - smooth fit interfaces at chi=0.6 and 14.
 !  MELANGE8 replaced by MELANGE9 - slightly modified input/output
-! 08.08.11 - corrected mistake (unlikely to have an effect) in CHEMFIT7
-! 16.11.11 - ELECT9 upgraded to ELECT11 (additional output)
-! 20.04.12 - FHARM8 and HLfit8 upgraded to FHARM12 and HLfit12:
-!   output of HLfit12 does not include zero-point vibr., but provides U1
-! 22.12.12 - MELANGE9 now includes a correction to the linear mixing
-!   rule (LMR) for the Madelung energy in the random bcc multi-ion
-!   lattice.
-! 14.05.13 - an accidental error in programming the newly introduced
-!   correction to the LMR is fixed.
-! 20.05.13 - calculation of the Wigner-Kirkwood quantum diffraction term
-!   for the liquid plasma is moved from EOSFI8 into MELANGE9.
-! 10.12.14 - slight cleaning of the text (no effect on the results)
-! 28.05.15 - an accidental error in Wigner-Kirkwood entropy correction
-!   is fixed (it was in the line "Stot=Stot+FWK*DENSI" since 20.05.13).
 !***********************************************************************
 !                           MAIN program:               Version 02.06.09
 ! This driving routine allows one to compile and run this code "as is".
@@ -109,27 +92,24 @@
 ! file to another (external) code, therefore the MAIN program is
 ! normally commented-out.
 ! C%C      implicit double precision (A-H), double precision (O-Z)
-! C%C      parameter(MAXY=10,UN_T6=.3157746,EPS=1.d-7)
+! C%C      parameter(MAXY=10,UN_T6=.3157746d0)
 ! C%C      dimension AY(MAXY),AZion(MAXY),ACMI(MAXY)
 ! C%C      write(*,'('' Introduce the chemical composition (up to'',I3,
 ! C%C     *  '' ion species):''/
 ! C%C     *  '' charge number Z_i, atomic weight A_i,'',
 ! C%C     *  '' partial number density x_i, derivatives d x_i / d ln T'',
 ! C%C     *  '' and d x_i / d ln rho''/
-! C%C     /   '' (non-positive Z, A, or x=1 terminates the input)'')') MAXY
+! C%C     /   '' (non-positive Z, A, or x terminates the input)'')') MAXY
 ! C%C      NMIX=0
 ! C%C    3 continue
-! C%C      XSUM=0.
 ! C%C      do IX=1,MAXY
 ! C%C         write(*,'(''Z, A ('',I2,''): ''$)') IX
 ! C%C         read*,AZion(IX),ACMI(IX)
 ! C%C        if (AZion(IX).le.0..or.ACMI(IX).le.0.) goto 2
 ! C%C         write(*,'(''x ('',I2,''): ''$)') IX
 ! C%C         read*,AY(IX)
-! C%C         XSUM=XSUM+AY(IX)
-! C%C        if (AY(IX).le.0.) goto 2
+! C%C        if (AY(IX).le.0..or.ACMI(IX).le.0.) goto 2
 ! C%C         NMIX=IX
-! C%C        if (dabs(XSUM-1.d0).lt.EPS) goto 2
 ! C%C      enddo
 ! C%C    2 continue
 ! C%C      if (NMIX.eq.0) then
@@ -140,16 +120,9 @@
 ! C%C      do IX=1,NMIX
 ! C%C         write(*,113) IX,AZion(IX),ACMI(IX),AY(IX)
 ! C%C      enddo
-! C%C    9 continue
-! C%C      write(*,'('' Input T (K) (<0 to stop): ''$)')
-! C%C      read*,T
-! C%C      if (T.le.0.) stop
 ! C%C   10 continue
-! C%C      write(*,'('' Input RHO [g/cc] (<0 to new T): ''$)')
-! C%C      read*,RHO
-! C%C      if (RHO.le.0.) goto 9
-! C%C      RHOlg=dlog10(RHO)
-! C%C      Tlg=dlog10(T)
+! C%C      write(*,'('' Input lg(RHO) [g/cc], lg(T) (K) : ''$)')
+! C%C      read*,RHOlg,Tlg
 ! C%C      T6=10.d0**(Tlg-6.d0)
 ! C%C      RHO=10.d0**RHOlg
 ! C%C      write(*,112)
@@ -192,12 +165,10 @@
          GAMIlo,GAMIhi,PRADnkT, &
          DENS,Zmean,CMImean,Z2mean,GAMImean,CHI,TPT,LIQSOL, &
          PnkT,UNkT,SNk,CV,CHIR,CHIT,ierr)
-!                                                       Version 20.05.13
-!                                           slight optimization 10.12.14
-!          Wigner-Kirkwood correction for the entropy corrected 28.05.15
+!                                                       Version 21.01.10
 ! Stems from MELANGE8 v.26.12.09.
 ! Difference: output PRADnkT instead of input KRAD
-! + EOS of fully ionized electron-ion plasma mixture.     
+! EOS of fully ionized electron-ion plasma mixture.     
 ! Limitations:
 ! (a) inapplicable in the regimes of
 !      (1) bound-state formation,
@@ -236,60 +207,52 @@
 !         CHIT = (d ln P / d ln T)_V ("\chi_T")
       integer, intent(in) :: NMIX
       integer, intent(out) :: LIQSOL, ierr
-      real(dp), intent(in) :: AZion(:), ACMI(:), GAMIlo, GAMIhi
       real(dp), intent(inout) :: AY(:)
-      type(auto_diff_real_2var_order1), intent(in) :: RHO, TEMP
-      type(auto_diff_real_2var_order1), intent(out) :: PRADnkT, DENS, GAMImean
-      real(dp), intent(out) :: Zmean, CMImean, Z2mean
-      type(auto_diff_real_2var_order1), intent(out) :: CHI, TPT, PnkT, UNkT, SNk, CV, CHIR, CHIT
+      real(dp), intent(in) :: AZion(:), ACMI(:), RHO, TEMP, GAMIlo, GAMIhi
+      real(dp), intent(out) :: PRADnkT, DENS, Zmean, CMImean, Z2mean, GAMImean
+      real(dp), intent(out) :: CHI, TPT, PnkT, UNkT, SNk, CV, CHIR, CHIT
       
-      integer :: IX, I, J
-      real(dp) :: Y, Z13, Z52, Z53, Z73, Z321, Zion, CMI
-      type(auto_diff_real_2var_order1) :: UINTRAD, PRESSRAD
-      type(auto_diff_real_2var_order1) :: FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE
-      type(auto_diff_real_2var_order1) :: DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT
-      type(auto_diff_real_2var_order1) :: DTE, PRESSE, UINTE, RS, RSI
-      type(auto_diff_real_2var_order1) :: GAME, alfa, beta, TPT2
-      type(auto_diff_real_2var_order1) :: UINT, PRESS, CVtot, Stot, PDLT, PDLR
-      type(auto_diff_real_2var_order1) :: DENSI, PRESSI, GAMI, DNI, PRI
-      type(auto_diff_real_2var_order1) :: FC1,UC1,PC1,SC1,CV1,PDT1,PDR1
-      type(auto_diff_real_2var_order1) :: FC2,UC2,PC2,SC2,CV2,PDT2,PDR2
-      type(auto_diff_real_2var_order1) :: FC1_0,UC1_0,PC1_0,SC1_0,CV1_0,PDT1_0,PDR1_0
-      type(auto_diff_real_2var_order1) :: FC2_0,UC2_0,PC2_0,SC2_0,CV2_0,PDT2_0,PDR2_0
-      type(auto_diff_real_2var_order1) :: FC1_1,UC1_1,PC1_1,SC1_1,CV1_1,PDT1_1,PDR1_1
-      type(auto_diff_real_2var_order1) :: FC2_1,UC2_1,PC2_1,SC2_1,CV2_1,PDT2_1,PDR2_1
-      type(auto_diff_real_2var_order1) :: FMIX,UMIX,PMIX,CVMIX,PDTMIX,PDRMIX
-
-
-      type(auto_diff_real_2var_order1) :: CTP, FWK, UWK
-      type(auto_diff_real_2var_order1) :: X, X1, X2, RZ, DeltaG
+      integer :: IX
+      real(dp) :: Y, Z13, Z52, Z53, Z73, Z321
+      real(dp) :: UINTRAD, PRESSRAD
+      real(dp) :: FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN
+      real(dp) :: DTE, PRESSE, UINTE, RS, RSI
+      real(dp) :: GAME, alfa, beta, TPT2
+      real(dp) :: UINT, PRESS, CVtot, Stot, PDLT, PDLR
+      real(dp) :: DENSI, PRESSI, CMI, GAMI, Zion, DNI, PRI
+      real(dp) :: FC1,UC1,PC1,SC1,CV1,PDT1,PDR1
+      real(dp) :: FC2,UC2,PC2,SC2,CV2,PDT2,PDR2
+      real(dp) :: FC1_0,UC1_0,PC1_0,SC1_0,CV1_0,PDT1_0,PDR1_0
+      real(dp) :: FC2_0,UC2_0,PC2_0,SC2_0,CV2_0,PDT2_0,PDR2_0
+      real(dp) :: FC1_1,UC1_1,PC1_1,SC1_1,CV1_1,PDT1_1,PDR1_1
+      real(dp) :: FC2_1,UC2_1,PC2_1,SC2_1,CV2_1,PDT2_1,PDR2_1
+      real(dp) :: FMIX,UMIX,PMIX,CVMIX,PDTMIX,PDRMIX
 
       real(dp), parameter :: TINY=1.d-7
       real(dp), parameter :: AUM=1822.888d0 ! a.m.u./m_e
-      real(dp), parameter :: GAMIMELT=175.d0 ! OCP value of Gamma_i for melting (not used, replaced by GAMIlo/hi)
+      real(dp), parameter :: GAMIMELT=175. ! OCP value of Gamma_i for melting (not used, replaced by GAMIlo/hi)
       real(dp), parameter :: RSIMELT=140.d0 ! ion density parameter of quantum melting
       real(dp), parameter :: RAD=2.5568570411948021d-07 ! Radiation constant (=4\sigma/c) (in a.u.)
-
-
+!     real(dp), parameter :: RAD=2.554d-7 ! Radiation constant (=4\sigma/c) (in a.u.)
       ierr = 0
       Y=0.d0
       do IX=1,NMIX
          Y=Y+AY(IX)
       enddo
-      if (abs(Y-1.d0).gt.TINY) then
+      if (dabs(Y-1.d0).gt.TINY) then
         do IX=1,NMIX
            AY(IX)=AY(IX)/Y
         enddo
 !         print*,'MELANGE9: partial densities (and derivatives)',
 !     *    ' are rescaled by factor',1./Y
       endif
-      Zmean=0d0
-      Z2mean=0d0
-      Z52=0d0
-      Z53=0d0
-      Z73=0d0
-      Z321=0d0 ! corr.26.12.09
-      CMImean=0d0
+      Zmean=0.
+      Z2mean=0.
+      Z52=0.
+      Z53=0.
+      Z73=0.
+      Z321=0. ! corr.26.12.09
+      CMImean=0.
       do IX=1,NMIX
          if (AY(IX) < TINY) cycle
          Zmean=Zmean+AY(IX)*AZion(IX)
@@ -303,16 +266,14 @@
       enddo
 ! (0) Photons:
       UINTRAD=RAD*TEMP*TEMP*TEMP*TEMP
-      PRESSRAD=UINTRAD/3d0
+      PRESSRAD=UINTRAD/3.
 !      CVRAD=4.*UINTRAD/TEMP
 ! (1) ideal electron gas (including relativity and degeneracy)  -----  *
       DENS=RHO/11.20587d0*Zmean/CMImean ! number density of electrons [au]
       call CHEMFIT(DENS,TEMP,CHI)
-
 ! NB: CHI can be used as true input instead of RHO or DENS
-      call ELECT11(TEMP,CHI, &
-        DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE, &
-        DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT)
+      call ELECT9(TEMP,CHI, &
+        DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN)
 ! NB: at this point DENS is redefined (the difference can be ~0.1%)
       DTE=DENS*TEMP
       PRESSE=PEid*DTE ! P_e [a.u.]
@@ -320,7 +281,7 @@
 ! (2) non-ideal Coulomb EIP  ----------------------------------------  *
       RS=pow(0.75d0/PI/DENS,1d0/3d0) ! r_s - electron density parameter
       RSI=RS*CMImean*Z73*AUM ! R_S - ion density parameter
-      GAME=1d0/RS/TEMP ! electron Coulomb parameter Gamma_e
+      GAME=1./RS/TEMP ! electron Coulomb parameter Gamma_e
       GAMImean=Z53*GAME   ! effective Gamma_i - ion Coulomb parameter
       if (RSI.lt.RSIMELT) then ! doesn't happen in "typical" wd cases
          LIQSOL=0 ! liquid regime
@@ -333,6 +294,14 @@
          alfa = (GAMImean - GAMIlo)/(GAMIhi - GAMIlo) ! 1 for solid, 0 for liquid
          beta = 1d0 - alfa
       endif
+      TPT2=0.
+      do IX=1,NMIX
+         if (AY(IX) < TINY) cycle
+         TPT2=TPT2+AY(IX)*GAME*GAME/RS*3./(AUM*ACMI(IX))*AZion(IX)
+! In the case of a mixture, this estimate of the quantum ion parameter
+! is as crude as the linear mixing model for Fharm employed below.
+      enddo
+      TPT=dsqrt(TPT2) ! effective T_p/T - ion quantum parameter
 ! Calculate partial thermodynamic quantities and combine them together:
       UINT=UINTE
       PRESS=PRESSE
@@ -342,15 +311,13 @@
       PDLR=PRESSE*CHIRE ! d P_e[a.u.] / d ln\rho
       DENSI=DENS/Zmean ! number density of all ions
       PRESSI=DENSI*TEMP ! ideal-ions total pressure (normalization)
-      TPT2=0d0
-      CTP=4.d0*PI/AUM/(TEMP*TEMP) ! common coefficient for TPT2.10.12.14
 ! Add Coulomb+xc nonideal contributions, and ideal free energy:
       do IX=1,NMIX
-         if (AY(IX).lt.TINY) cycle ! skip this species
+        if (AY(IX).lt.TINY) cycle ! skip this species
          Zion=AZion(IX)
-         if (Zion.eq.0d0) cycle ! skip neutrons
+         if (Zion.eq.0) cycle ! skip neutrons
          CMI=ACMI(IX)
-         GAMI=pow(Zion,5d0/3d0)*GAME ! Gamma_i for given ion species
+         GAMI=pow(Zion,5d0/3d0)/RS/TEMP ! Gamma_i for given ion species
          DNI=DENSI*AY(IX) ! number density of ions of given type
          PRI=DNI*TEMP ! = ideal-ions partial pressure (normalization)         
          if (LIQSOL == 0 .or. LIQSOL == 1) then
@@ -387,59 +354,13 @@
          Stot=Stot+DNI*(SC2-log(AY(IX))) !entropy per unit volume[a.u.]
          PRESS=PRESS+PC2*PRI ! pressure (e+i+Coul.) [a.u.]
 ! Second-order functions (they take into account compositional changes):
-         CVtot=CVtot+DNI*CV2 ! C_V (e+i+Coul.)/ V (optim.10.12.14)
+         CVtot=CVtot+DENSI*CV2*AY(IX) ! C_V (e+i+Coul.)/ V
          PDLT=PDLT+PRI*PDT2 ! d P / d ln T
          PDLR=PDLR+PRI*PDR2 ! d P / d ln\rho
-         TPT2=TPT2+CTP*DNI/ACMI(IX)*AZion(IX)**2 ! opt.10.12.14
       enddo ! next IX
-! Wigner-Kirkwood perturbative correction for liquid:
-      TPT=sqrt(TPT2) ! effective T_p/T - ion quantum parameter
-! (in the case of a mixture, this estimate is crude)
-      if (LIQSOL.eq.0) then
-         FWK=TPT2/24.d0 ! Wigner-Kirkwood (quantum diffr.) term
-         ! MESA doesn't warn/error when this term gets large because
-         ! it is not clear that we are better off falling back to HELM
-         !
-         ! if (FWK.gt..7d0) then
-         !    print*,'MELANGE9: strong quantum effects in liquid!'
-         !    ierr = -1
-         !    return
-         ! endif
-         UWK=2.d0*FWK
-         UINT=UINT+UWK*PRESSI
-         Stot=Stot+FWK*DENSI ! corrected 28.05.15
-         PRESS=PRESS+FWK*PRESSI
-         CVtot=CVtot-UWK*DENSI ! corrected by JWS 17.04.20
-         PDLT=PDLT-FWK*PRESSI
-         PDLR=PDLR+UWK*PRESSI
-      endif
 ! Corrections to the linear mixing rule:
-      if (LIQSOL.eq.0) then ! liquid phase
-         call CORMIX(RS,GAME,Zmean,Z2mean,Z52,Z53,Z321, &
-           FMIX,UMIX,PMIX,CVMIX,PDTMIX,PDRMIX)
-      else ! solid phase (only Madelung contribution) [22.12.12]
-        FMIX=0d0
-        do I=1,NMIX
-           if (AY(I).lt.TINY) cycle
-          do J=I+1,NMIX
-             if (AY(J).lt.TINY) cycle
-             RZ=AZion(J)/AZion(I)
-             X2=AY(J)/(AY(I)+AY(J))
-             X1=dim(1.d0,X2)
-             if (X2.lt.TINY) cycle
-             X=X2/RZ+(1.d0-1.d0/RZ)*pow(X2, RZ)
-             GAMI=pow(AZion(I),5d0/3d0)*GAME ! Gamma_i corrected 14.05.13
-             DeltaG=.012d0*(1.d0-1.d0/pow2(RZ))*(X1+X2*pow(RZ,5d0/3d0))
-             DeltaG=DeltaG*X/X2*dim(1.d0,X)/X1
-             FMIX=FMIX+AY(I)*AY(J)*GAMI*DeltaG
-          enddo
-        enddo
-         UMIX=FMIX
-         PMIX=FMIX/3.d0
-         CVMIX=0d0
-         PDTMIX=0d0
-         PDRMIX=FMIX/2.25d0
-      endif
+      call CORMIX(RS,GAME,Zmean,Z2mean,Z52,Z53,Z321, &
+        FMIX,UMIX,PMIX,CVMIX,PDTMIX,PDRMIX)
       UINT=UINT+UMIX*PRESSI
       Stot=Stot+DENSI*(UMIX-FMIX)
       PRESS=PRESS+PMIX*PRESSI
@@ -466,9 +387,6 @@
         FC1,UC1,PC1,SC1,CV1,PDT1,PDR1, &
         FC2,UC2,PC2,SC2,CV2,PDT2,PDR2,ierr)
 !                                                       Version 16.09.08
-!                 call FHARM8 has been replaced by call FHARM12 27.04.12
-!                           Wigner-Kirkwood correction excluded 20.05.13
-!                                               slight cleaning 10.12.14
 ! Non-ideal parts of thermodynamic functions in the fully ionized plasma
 ! Stems from EOSFI5 and EOSFI05 v.04.10.05
 ! Input: LIQSOL=0/1(liquid/solid), 
@@ -479,57 +397,53 @@
 !         free and internal energies (per ion per kT),
 !         PC1 - analogous contribution to pressure divided by (n_i kT),
 !         CV1 - "ii+ie+ee" heat capacity per ion [units of k]
-!         PDT1=(1/n_i kT)*(d P_C/d ln T)_V
-!         PDR1=(1/n_i kT)*(d P_C/d ln\rho)_T
+!         PDT1=(1/N_i kT)*(d P_C/d ln T)_V
+!         PDR1=(1/N_i kT)*(d P_C/d ln\rho)_T
 ! FC2,UC2,PC2,SC2,CV2 - analogous to FC1,UC1,PC1,SC1,CV1, but including
 ! the part corresponding to the ideal ion gas. This is useful for 
 ! preventing accuracy loss in some cases (e.g., when SC2 << SC1).
 ! FC2 does not take into account the entropy of mixing S_{mix}: in a
 ! mixture, S_{mix}/(N_i k) has to be added externally (see MELANGE9).
-! FC2 does not take into account the ion spin degeneracy either.
-! When needed, the spin term must be added to the entropy externally.
       integer, intent(in) :: LIQSOL
-      real(dp), intent(in) :: CMI, Zion
-      type(auto_diff_real_2var_order1), intent(in) :: RS, GAMI
-      type(auto_diff_real_2var_order1), intent(out) :: FC1,UC1,PC1,SC1,CV1,PDT1,PDR1
-      type(auto_diff_real_2var_order1), intent(out) :: FC2,UC2,PC2,SC2,CV2,PDT2,PDR2
+      real(dp), intent(in) :: CMI, Zion, RS, GAMI
+      real(dp), intent(out) :: FC1,UC1,PC1,SC1,CV1,PDT1,PDR1
+      real(dp), intent(out) :: FC2,UC2,PC2,SC2,CV2,PDT2,PDR2
       integer, intent(out) :: ierr
 
-      type(auto_diff_real_2var_order1) :: GAME,FXC,UXC,PXC,CVXC,SXC,PDTXC,PDRXC
-      type(auto_diff_real_2var_order1) :: TPT, COTPT, FidION
-      type(auto_diff_real_2var_order1) :: FION, UION, PION, CVii, PDTii, PDRii
-      type(auto_diff_real_2var_order1) :: FItot, UItot, PItot, CVItot, SCItot
-      type(auto_diff_real_2var_order1) :: PDTi, PDRi
-      type(auto_diff_real_2var_order1) :: Fharm,Uharm,Pharm,CVharm,Sharm,PDTharm,PDRharm
-      type(auto_diff_real_2var_order1) :: Fah,Uah,Pah,CVah,PDTah,PDRah
-      type(auto_diff_real_2var_order1) :: FSCR,USCR,PSCR,S_SCR,CVSCR,PDTSCR,PDRSCR
-      type(auto_diff_real_2var_order1) :: FC0, UC0, PC0, SC0, CV0, PDT0, PDR0
+      real(dp) :: GAME,FXC,UXC,PXC,CVXC,SXC,PDTXC,PDRXC
+      real(dp) :: TPT, COTPT, FidION
+      real(dp) :: FION, UION, PION, CVii, PDTii, PDRii
+      real(dp) :: FItot, UItot, PItot, CVItot, SCItot
+      real(dp) :: PDTi, PDRi, FWK, UWK, CVWK, PWK, PDRWK, PDTWK
+      real(dp) :: Fharm,Uharm,Pharm,CVharm,Sharm,PDTharm,PDRharm
+      real(dp) :: Fah,Uah,Pah,CVah,PDTah,PDRah
+      real(dp) :: FSCR,USCR,PSCR,S_SCR,CVSCR,PDTSCR,PDRSCR
+      real(dp) :: FC0, UC0, PC0, SC0, CV0, PDT0, PDR0
       
-      real(dp), parameter :: TINY=1.d-20 
+      real(dp), parameter :: TINY=1.d-20 ! prevents division by zero
       real(dp), parameter :: AUM=1822.888d0 ! a.m.u/m_e
-
       ierr = 0
       if (LIQSOL.ne.1.and.LIQSOL.ne.0) then
          ierr = -1
          return
          !stop 'EOSFI8: invalid LIQSOL'
       end if
-      if (CMI.le..1d0)  then
+      if (CMI.le..1)  then
          ierr = -1
          return
          !stop 'EOSFI8: too small CMI'
       end if
-      if (Zion.le..1d0)  then
+      if (Zion.le..1)  then
          ierr = -1
          return
          !stop 'EOSFI8: too small Zion'
       end if
-      if (RS.le..0d0)  then
+      if (RS.le..0)  then
          ierr = -1
          return
          !stop 'EOSFI8: invalid RS'
       end if
-      if (GAMI.le..0d0)  then
+      if (GAMI.le..0)  then
          ierr = -1
          return
          !stop 'EOSFI8: invalid GAMI'
@@ -537,8 +451,8 @@
       GAME=GAMI/pow(Zion,5d0/3d0)
       call EXCOR7(RS,GAME,FXC,UXC,PXC,CVXC,SXC,PDTXC,PDRXC) ! "ee"("xc")
 ! Calculate "ii" part:
-      COTPT=sqrt(3d0/AUM/CMI)/pow(Zion,7d0/6d0) ! auxiliary coefficient
-      TPT=GAMI/sqrt(RS)*COTPT              ! T_p/T
+      COTPT=dsqrt(3./AUM/CMI)/pow(Zion,7d0/6d0) ! auxiliary coefficient
+      TPT=GAMI/dsqrt(RS)*COTPT              ! T_p/T
       FidION=1.5d0*log(TPT*TPT/GAMI)-1.323515d0
 ! 1.3235=1+0.5*ln(6/pi); FidION = F_{id.ion gas}/(N_i kT), but without
 ! the term x_i ln x_i = -S_{mix}/(N_i k).
@@ -552,8 +466,14 @@
          SCItot=UItot-FItot
          PDTi=PDTii+1.d0
          PDRi=PDRii+1.d0
+         FWK=TPT*TPT/24. ! Wigner-Kirkwood (quantum diffr.) term
+         UWK=2.*FWK
+         CVWK=-UWK
+         PWK=FWK
+         PDRWK=2.*PWK
+         PDTWK=-PWK
       else                                  ! solid
-         call FHARM12(GAMI,TPT, &
+         call FHARM8(GAMI,TPT, &
            Fharm,Uharm,Pharm,CVharm,Sharm,PDTharm,PDRharm) ! harm."ii"
          call ANHARM8(GAMI,TPT,Fah,Uah,Pah,CVah,PDTah,PDRah) ! anharm.
          FItot=Fharm+Fah
@@ -569,6 +489,12 @@
          CVItot=CVharm+CVah
          SCItot=Sharm+Uah-Fah
          CVii=CVItot-1.5d0 ! minus 1.5=ideal-gas
+         FWK=0.
+         UWK=0.
+         PWK=0.
+         CVWK=0.
+         PDRWK=0.
+         PDTWK=0.
       endif
 ! Calculate "ie" part:
       if (LIQSOL.eq.1) then
@@ -582,13 +508,13 @@
          S_SCR=USCR-FSCR
       endif
 ! Total excess quantities ("ii"+"ie"+"ee", per ion):
-      FC0=FSCR+Zion*FXC
-      UC0=USCR+Zion*UXC
-      PC0=PSCR+Zion*PXC
-      SC0=S_SCR+Zion*SXC
-      CV0=CVSCR+Zion*CVXC
-      PDT0=PDTSCR+Zion*PDTXC
-      PDR0=PDRSCR+Zion*PDRXC
+      FC0=FSCR+Zion*FXC+FWK
+      UC0=USCR+Zion*UXC+UWK
+      PC0=PSCR+Zion*PXC+PWK
+      SC0=S_SCR+Zion*SXC+FWK
+      CV0=CVSCR+Zion*CVXC+CVWK
+      PDT0=PDTSCR+Zion*PDTXC+PDTWK
+      PDR0=PDRSCR+Zion*PDRXC+PDRWK
       FC1=FION+FC0
       UC1=UION+UC0
       PC1=PION+PC0
@@ -622,141 +548,33 @@
 !         PDTii = PION + d(PION)/d ln T = (1/N_i kT)*(d P_{ii}/d ln T)
 !         PDRii = PION + d(PION)/d ln\rho
 !   Parameters adjusted to Caillol (1999).
-      use pc_support
-      type(auto_diff_real_2var_order1), intent(in) :: GAMI
-      type(auto_diff_real_2var_order1), intent(out) :: FION, UION, PION, CVii, PDTii, PDRii
-      type(auto_diff_real_2var_order1) :: F0, U0
-
+      real(dp), intent(in) :: GAMI
+      real(dp), intent(out) :: FION, UION, PION, CVii, PDTii, PDRii
+      real(dp) :: F0, U0
+      
       real(dp), parameter :: A1=-.907347d0
       real(dp), parameter :: A2=.62849d0
-      real(dp) :: A3
       real(dp), parameter :: C1=.004500d0
-      real(dp), parameter :: G1=170.0d0
+      real(dp), parameter :: G1=170.0
       real(dp), parameter :: C2=-8.4d-5
-      real(dp), parameter :: G2=.0037d0
+      real(dp), parameter :: G2=.0037
       real(dp), parameter :: SQ32=.8660254038d0 ! SQ32=sqrt(3)/2
-      
-      real(dp) :: &
-         xFION, dFION_dlnGAMI, &
-         xUION, dUION_dlnGAMI, &
-         xPION, dPION_dlnGAMI, &
-         xCVii, dCVii_dlnGAMI, &
-         xPDTii, dPDTii_dlnGAMI, &
-         xPDRii, dPDRii_dlnGAMI
-      real(dp) :: dlnGAMI_dT, dlnGAMI_dRho
-      integer :: ierr
-      logical :: skip
-      logical, parameter :: use_FITION9_table = .false.
-      logical, parameter :: debug_FITION9_table = .false.
-
-
-      if (.not. use_FITION9_table .or. debug_FITION9_table) then
-
-         A3=-SQ32-A1/sqrt(A2)
-         F0=A1*(sqrt(GAMI*(A2+GAMI)) &
-            - A2*log(sqrt(GAMI/A2)+sqrt(1d0+GAMI/A2))) &
-            + 2d0*A3*(sqrt(GAMI)-atan(sqrt(GAMI)))
-         U0=pow3(sqrt(GAMI))*(A1/sqrt(A2+GAMI)+A3/(1.d0+GAMI))
-         !   This is the zeroth approximation. Correction:
-         UION=U0+C1*GAMI*GAMI/(G1+GAMI)+C2*GAMI*GAMI/(G2+GAMI*GAMI)
-         FION=F0+C1*(GAMI-G1*log(1.d0+GAMI/G1)) &
-            + C2/2d0*log(1.d0+GAMI*GAMI/G2)
-         CVii=-0.5d0*pow3(sqrt(GAMI))*(A1*A2/pow3(sqrt(A2+GAMI)) &
-            + A3*(1.d0-GAMI)/pow2(1.d0+GAMI)) &
-            - GAMI*GAMI*(C1*G1/pow2(G1+GAMI)+C2*(G2-GAMI*GAMI)/pow2(G2+GAMI*GAMI))
-         PION=UION/3.0d0
-         PDRii=(4.0d0*UION-CVii)/9.0d0 ! p_{ii} + d p_{ii} / d ln\rho
-         PDTii=CVii/3.0d0 ! p_{ii} + d p_{ii} / d ln T
-
-      endif
-      
-      if (use_FITION9_table .or. debug_FITION9_table) then
-         ierr = 0
-         call get_FITION9(GAMI%val, &
-            xFION, dFION_dlnGAMI, &
-            xUION, dUION_dlnGAMI, &
-            xPION, dPION_dlnGAMI, &
-            xCVii, dCVii_dlnGAMI, &
-            xPDTii, dPDTii_dlnGAMI, &
-            xPDRii, dPDRii_dlnGAMI, &
-            skip, ierr)
-         if (ierr /= 0) stop 'failed in call get_FITION9'
-      else
-         skip = .true.
-      end if
-
-
-      if (debug_FITION9_table .and. .not. skip) then
-
-         if (.not. check1(FION, xFION, 'FION')) return
-         if (.not. check1(UION, xUION, 'UION')) return
-         if (.not. check1(PION, xPION, 'PION')) return
-         if (.not. check1(CVii, xCVii, 'CVii')) return
-         if (.not. check1(PDTii, xPDTii, 'PDTii')) return
-         if (.not. check1(PDRii, xPDRii, 'PDRii')) return
-
-      endif
-
-
-      if (use_FITION9_table .and. .not. skip) then
-
-         ! values
-         FION% val = xFION
-         UION% val = xUION
-         PION% val = xPION
-         CVii% val = xCVii
-         PDTii% val = xPDTii
-         PDRii% val = xPDRii
-
-         ! dT (val1) derivatives
-         ! dlnRs_dT = RS% d1val1 / RS% val = 0
-         dlnGAMI_dT = GAMI% d1val1 / GAMI% val
-
-         FION% d1val1 = dFION_dlnGAMI * dlnGAMI_dT
-         UION% d1val1 = dUION_dlnGAMI * dlnGAMI_dT
-         PION% d1val1 = dPION_dlnGAMI * dlnGAMI_dT
-         CVii% d1val1 = dCVii_dlnGAMI * dlnGAMI_dT
-         PDTii% d1val1 = dPDTii_dlnGAMI * dlnGAMI_dT
-         PDRii% d1val1 = dPDRii_dlnGAMI * dlnGAMI_dT
-
-         ! dRho (val2) derivatives
-         dlnGAMI_dRho = GAMI% d1val2 / GAMI% val
-
-         FION% d1val2 = dFION_dlnGAMI * dlnGAMI_dRho
-         UION% d1val2 = dUION_dlnGAMI * dlnGAMI_dRho
-         PION% d1val2 = dPION_dlnGAMI * dlnGAMI_dRho
-         CVii% d1val2 = dCVii_dlnGAMI * dlnGAMI_dRho
-         PDTii% d1val2 = dPDTii_dlnGAMI * dlnGAMI_dRho
-         PDRii% d1val2 = dPDRii_dlnGAMI * dlnGAMI_dRho
-
-      end if
-
-
-      contains
-      
-      logical function check1(v, xv, str)
-         type(auto_diff_real_2var_order1), intent(in) :: v
-         real(dp), intent(in) :: xv
-         character (len=*), intent(in) :: str
-         real(dp) :: val
-         real(dp), parameter :: atol = 1d-8, rtol = 1d-6
-         include 'formats'
-         val = v%val
-         check1 = .false.
-         if (is_bad(xv)) then
-            write(*,*) 'is_bad ' // trim(str), xv, val, GAMI
-            return
-         end if
-         if (abs(val - xv) > atol + rtol*max(abs(val),abs(xv))) then
-            write(*,*) 'rel mismatch ' // trim(str), &
-               (val - xv)/max(abs(val),abs(xv),1d-99), &
-               xv, val, GAMI%val
-            stop 'FITION9'
-            return
-         end if
-         check1 = .true.
-      end function check1
-
+      real(dp), parameter :: A3=-SQ32-A1/dsqrt(A2)
+      F0=A1*(dsqrt(GAMI*(A2+GAMI)) &
+         - A2*log(dsqrt(GAMI/A2)+dsqrt(1.+GAMI/A2))) &
+         + 2.*A3*(dsqrt(GAMI)-atan(dsqrt(GAMI)))
+      U0=pow3(sqrt(GAMI))*(A1/dsqrt(A2+GAMI)+A3/(1.d0+GAMI))
+!   This is the zeroth approximation. Correction:
+      UION=U0+C1*GAMI*GAMI/(G1+GAMI)+C2*GAMI*GAMI/(G2+GAMI*GAMI)
+      FION=F0+C1*(GAMI-G1*log(1.d0+GAMI/G1)) &
+         + C2/2.*log(1.d0+GAMI*GAMI/G2)
+      CVii=-0.5d0*pow3(sqrt(GAMI))*(A1*A2/pow3(sqrt(A2+GAMI)) &
+         + A3*(1.d0-GAMI)/pow2(1.d0+GAMI)) &
+         - GAMI*GAMI*(C1*G1/pow2(G1+GAMI)+C2*(G2-GAMI*GAMI)/pow2(G2+GAMI*GAMI))
+      PION=UION/3.0d0
+      PDRii=(4.0d0*UION-CVii)/9.0d0 ! p_{ii} + d p_{ii} / d ln\rho
+      PDTii=CVii/3.0d0 ! p_{ii} + d p_{ii} / d ln T
+      return
       end subroutine FITION9
 
       subroutine FSCRliq8(RS,GAME,Zion, &
